#include <mega128.h>
#include "sub/io.c"    
#include "sub/sys.c"
#include "sub/i3202lcd.c"
#include "sub/ov9640.c"
   

void histogram(unsigned char * luminance)
{
   unsigned char n,m;
              
   for(n=0;n<128;n++) luminance[n]=luminance[n]>>1;  // divide by 2
   
   LcdSetWindow(160+10,60,128,120);
   LcdDataStart();
   for(m=0;m<120;m++)
    {  for(n=0;n<128;n++)
         {    
              if(luminance[n]<m) {  LcdDataH(0xff); LcdDataL(0xff); LcdWr(1); LcdWr(0); }
              else  {  LcdDataH(0x00); LcdDataL(0x00); LcdWr(1); LcdWr(0); }
         }
    }             
   LcdDataEnd();
   
}

void main(void)  // 160*120
{                    
  unsigned long n;
  unsigned char i,j;     
  unsigned char Y,UV;
  unsigned char luminance[128];

  io_init();
  Sini(0,1152,0);

  LcdBl(1);
  LcdInit();                
  LcdSetDirection(90);
  
  LcdSetWindow(0,0,320,240);
  LcdDataStart();
  for(n=0;n<(320*240);n++) LcdData(0xffff);
  LcdDataEnd();
  
  LcdSetWindow(0,60,160,120);

  EnableAutoSetCM(); 
  SetYUVQQVGA();     // YUV   160*120

  while(1)
  {              
       CmReadyCapture(1);  CmReadyCapture(0);
       CmStartCapture(1);  CmStartCapture(0);

       histogram(luminance);
       for(i=0;i<128;i++) luminance[i]=0;

       while(CmEndCapture()==0);  
       CmReadyCapture(1);  CmReadyCapture(0);
                     
       LcdSetWindow(0,60,160,120);
       LcdDataStart();
       for(i=0;i<160;i++)
         {
            for(j=0;j<120;j++)
              {
                 CmRdData(1); 
                 CmRdData(0);
                 Y=CmData();
                 CmRdData(1);
                 CmRdData(0);
//                 UV=CmData();
                 
//                 LcdDataH((Y&0xf8)|(Y>>5));
//                 LcdDataL(((Y<<3)&0xe0)|(Y>>3));
                 LcdDataH(Y&0xf8);
                 LcdDataL(0x00);
                   
                   
                 LcdWr(1); LcdWr(0);
                 
                 Y=Y>>1; 
                 if(luminance[Y]<240) luminance[Y]++;
               }
           }
       LcdDataEnd(); 
  }

}