
void io_init(void)
{
  PORTA=0xD0;
  DDRA=0xFF;

  PORTB=0x00;
  DDRB=0x00;

  PORTC=0x00;
  DDRC=0x00;

  PORTD=0xEF;
  DDRD=0x71;

  PORTE=0xEC;
  DDRE=0x70;

  PORTF=0x00; 
  DDRF=0x00;

  PORTG=0x04;
  DDRG=0x1C;

  ACSR=0x80; // Analog Comparator: Off
}



#define UsbRxReady()  (!PINE.2)
#define UsbTxReady()  (!PINE.3)
#define UsbRd(X)      PORTE.5=(!X)
#define UsbWr(X)      PORTE.6=(!X)
#define UsbReady()    (!PINE.7)



#define CmEndCapture() PIND.3
#define CmReset(X)    PORTD.4=X   

#define CmAddrClock(X) PORTA.3=X
#define CmAddr1(X)     PORTA.2=X
#define CmAddr0(X)     PORTA.1=X
#define CmRdData(X)   PORTA.0=X
#define CmData()      PINF

void CmReadyCapture(unsigned char a)
{
   if(a) PORTG=PORTG|0x08;
   else PORTG=PORTG&0xf7;
}                    

void CmStartCapture(unsigned char a)
{
   if(a) PORTG=PORTG|0x10;
   else PORTG=PORTG&0xef;
}

void CmSetAddress(unsigned long addr)
{  
   DDRF=0xff;
   
   CmAddr1(0); CmAddr0(1);
   PORTF=addr&0xff;
   CmAddrClock(1); 
   CmAddrClock(0);
                         
   CmAddr1(1); CmAddr0(0);        
   PORTF=(addr>>8)&0xff;        
   CmAddrClock(1); 
   CmAddrClock(0);

   CmAddr1(1); CmAddr0(1);        
   PORTF=(addr>>16)&0xff;
   CmAddrClock(1); 
   CmAddrClock(0);               

   CmAddr1(0); CmAddr0(0);           

   DDRF=0x00;
   PORTF=0x00;
}



#define LcdBl(X)      PORTE.4=X
#define LcdDirWR(X)   PORTD.5=(!X)

#define LcdRd(X)      PORTA.7=(!X)
#define LcdWr(X)      PORTA.6=(!X)
#define LcdRs(X)      PORTA.5=X
#define LcdCs(X)      PORTA.4=(!X)

#define LcdDataH(X)   PORTB=X
#define LcdDataL(X)   PORTC=X

void LcdReset(unsigned char a)
{
   if(a) PORTG=PORTG&0xfb;
   else PORTG=PORTG|0x04;
}
                         

#define PenIrq()      (!PIND.2)