typedef     unsigned char   byte;
typedef     unsigned int    word;
typedef     unsigned char   BYTE;
typedef     unsigned int    WORD;
typedef     unsigned long   LONG;

#define    TRUE  1
#define    FALSE 0
#define    ON    1
#define    OFF   0

#define     NORCV    0x100

void delay(word DelayWait);
void mdelay(word MilliSecond);

void delay(word DelayWait)
{ while(DelayWait--);
}

void mdelay(unsigned int MilliSecond) 
{
     unsigned int a;
     while(MilliSecond--)
       { for(a=0;a<1974;a++);              // for AVR delay... 16Mhz
       }
}

/*============================ channel 0 ======================================*/
void putch0(byte ch)
{   while(!(UCSR0A&0x20));
    UDR0=ch;
}

byte getch0(void)
{
       while(!(UCSR0A&0x80));
       return(UDR0);
}

word getc0(void)
{
       if(!(UCSR0A&0x80)) return(NORCV);
       return(UDR0);
}                 

void put_string0(byte const *str)
{
	unsigned int i;
	for(i=0;str[i]!='\0';i++)
	  { putch0(str[i]);
	  }
} 

void put_hexbyte0(unsigned char ch)
{

    unsigned char hnibble,lnibble;

    lnibble=ch&0x0f;
    hnibble=ch>>4;

    if(hnibble<0x0a) hnibble=hnibble+0x30;
    else hnibble=hnibble+0x37;
    putch0(hnibble);

    if(lnibble<0x0a) lnibble=lnibble+0x30;
    else lnibble=lnibble+0x37;
    putch0(lnibble);
}

void put_hexword0(unsigned int ch)
{
    put_hexbyte0(ch>>8);
    put_hexbyte0(ch);
}

void put_decbyte0(unsigned char ch)
{
    unsigned char a,b,c;
    a=ch%10;
    b=ch%100;
    b=b/10;
    c=ch/100;
    putch0(c+0x30);
    putch0(b+0x30);
    putch0(a+0x30);
}

void put_decword0(unsigned int ch)
{
    unsigned char a=0,b=0,c=0,d=0,e=0;
    a=ch/10000;
    ch=ch%10000;
    b=ch/1000;
    ch=ch%1000;
    c=ch/100;
    ch=ch%100;
    d=ch/10;
    e=ch%10;
    putch0(a+0x30);
    putch0(b+0x30);
    putch0(c+0x30);
    putch0(d+0x30);
    putch0(e+0x30);
}
/*=============================================================================*/

/*============================ channel 1 ======================================*/
void putch1(byte ch)
{
    while(!(UCSR1A&0x20));
    UDR1=ch;
}

byte getch1(void)
{
       while(!(UCSR1A&0x80));
//       if(!(UCSR1A&0x80)) return(NORCV);
       return(UDR1);
}
                 
word getc1(void)
{
       if(!(UCSR1A&0x80)) return(NORCV);
       return(UDR1);
}

void put_string1(byte const *str)
{
	unsigned int i;
	for(i=0;str[i]!='\0';i++)
	  { putch1(str[i]);
	  }
} 


void put_hexbyte1(unsigned char ch)
{

    unsigned char hnibble,lnibble;

    lnibble=ch&0x0f;
    hnibble=ch>>4;

    if(hnibble<0x0a) hnibble=hnibble+0x30;
    else hnibble=hnibble+0x37;
    putch1(hnibble);

    if(lnibble<0x0a) lnibble=lnibble+0x30;
    else lnibble=lnibble+0x37;
    putch1(lnibble);
}

void put_hexword1(unsigned int ch)
{
    put_hexbyte1(ch>>8);
    put_hexbyte1(ch);
}

void put_decbyte1(unsigned char ch)
{
    unsigned char a,b,c;
    a=ch%10;
    b=ch%100;
    b=b/10;
    c=ch/100;
    putch1(c+0x30);
    putch1(b+0x30);
    putch1(a+0x30);
}

void put_decword1(unsigned int ch)
{
    unsigned char a=0,b=0,c=0,d=0,e=0;
    a=ch/10000;
    ch=ch%10000;
    b=ch/1000;
    ch=ch%1000;
    c=ch/100;
    ch=ch%100;
    d=ch/10;
    e=ch%10;
    putch1(a+0x30);
    putch1(b+0x30);
    putch1(c+0x30);
    putch1(d+0x30);
    putch1(e+0x30);
}
/*=============================================================================*/

/*************************** SYSTEM LIBRARY *******************************/

void Sini(unsigned char ch,unsigned int baud,unsigned char irq)   //4800bps ~ 115200bps  1~2 channel   Clock : 16Mhz
{
     switch(baud)
      {
         case 48:   baud=191;  break;
         case 96:   baud=95;   break;
         case 192:  baud=47;   break;
         case 384:  baud=23;   break;
         case 576:  baud=15;   break;
         default : baud=7;     break; //115200bps..
      }

     if(ch==1)
       {
         UCSR1A=0x00;  // uart status register
         if(irq==ON) UCSR1B=0x98;  // uart control register(RX:enable,TX:enable,interrupt:enable)
         else UCSR1B=0x18;  // uart control register(RX:enable,TX:enable,interrupt:disable)
         UCSR1C=0x06;  // USART1 Mode: Asynchronous
         
         UBRR1H=0x00;  // Baudrate high register     
         UBRR1L=baud;  // Baudrate low register           
       }
     else
       {      
         UCSR0A=0x00;  // uart status register
         if(irq==ON) UCSR0B=0x98;  // uart control register(RX:enable,TX:enable,interrupt:enable)
         else UCSR0B=0x18;  // uart control register(RX:enable,TX:enable,interrupt:disable)
         UCSR0C=0x06;  // USART1 Mode: Asynchronous
         
         UBRR0H=0x00;  // Baudrate high register     
         UBRR0L=baud;  // Baudrate low register
       }
  
}

void Shexword(byte ch, word dt)
{
 if(ch==1) put_hexword1(dt);
 else put_hexword0(dt);
}

void Shexbyte(byte ch, byte dt)
{
 if(ch==1) put_hexbyte1(dt);
 else put_hexbyte0(dt);
}

void Sdecword(byte ch, word dt)
{
 if(ch==1) put_decword1(dt);
 else put_decword0(dt);
}

void Sdecbyte(byte ch, byte dt)
{
 if(ch==1) put_decbyte1(dt);
 else put_decbyte0(dt);
}

void Sprint(byte ch,byte const *arr)
{
 if(ch==1) put_string1(arr);
 else put_string0(arr);
}

void Sputchar(byte ch, byte dt)
{
 if(ch==1) putch1(dt);
 else putch0(dt);
}

byte Sgetchar(byte ch)
{
 byte a=0;
 if(ch==1) a=getch1();
 else a=getch0();
 return a;
}                     

word Sget(byte ch)
{
 word a=0;
 if(ch==1) a=getc1();
 else a=getc0();
 return a;
}   
             
                                         
/*************************************************************************/

/*===================== for E2PROM =======================*/
void put_e2p(word addr,byte data)
{  while(EECR&0x02);
   EEAR=addr;
   EEDR=data;
   EECR|=0x04;
   EECR|=0x02;   
}            

byte get_e2p(word addr)
{   while(EECR&0x02);
    EEAR=addr;
    EECR|=0x01;
    return(EEDR);
}
/*========================================================*/